; fast320 - driver for 320x200x8 direct vram-access

        jmp startme

hline:
        push bx
        mov cx, si
        call calcme
        sub di, si
        mov cx, di
        mov di, bx
        pop ax
        inc cx
        rep stosb
        iret

fillrect:
        sti
        push bp
        push bx
        push dx
        call calcme
        pop dx
        sub si, cx
        sub di, dx
        mov cx, si
        mov dx, di

        mov di, bx
        mov bp, cx

        pop ax
        mov bx, 320
        sub bx, cx

docol:   mov es:[di], al
        inc di
        dec cx
        jnz docol

        add di, bx
        mov cx, bp
        dec dx
        jnz docol

        pop bp
        iret

dstrt:  cmp ah, cs:[mydrvid]
        jnz retjmp
    
        cmp al, 0
        jz retdata
        cmp al, 1
        jz retmode
        cmp al, 2
        jz setmode
        cmp al, 3
        jz setpixel
        cmp al, 4
        jz getpixel
        cmp al, 5
        jz hline
        cmp al, 6
        jz vline
        cmp al, 8
        jz fillrect
        cmp al, 0FFh
        jz freemem
notderstood:
        mov ax, 0FFFFh
        mov bx, 0FFFFh
        mov cx, 0FFFFh
        mov dx, 0FFFFh
        iret

retjmp: jmp 0FFFFh:0000h


retmode:
        mov ax, 320
        mov bx, 200
        mov cx, 8
        iret

retdata:
        xor ah, ah
        mov al, 1
        iret

freemem: mov ax, 3
        int 10h
    
        mov ax, cs
        xor bx, bx
        xor cx, cx
        xor dx, dx
        mov si, 1234h
        iret

setmode: mov ax, 13h
        int 10h
        iret

; 236(8), 64(6)

getpixel:
        call calcme
        mov bl, es:[bx]
        mov bh, 0
        iret

setpixel:
        push bx
        call calcme
        pop ax
        mov es:[bx], al
        iret

calcme:
        mov ax, 0A000h
        mov es, ax

        mov ax, dx
        shl ax, 8
        mov bx, ax

        mov ax, dx
        shl ax, 6
        add bx, ax

        add bx, cx
        ret

vline:
        push bx
        mov dx, si
        call calcme
        sub di, si
        mov cx, di
        mov di, bx
        pop ax
        inc cx

nbt:    mov es:[di], al
        add di, 320
        dec cx
        jnz nbt

        iret

mydrvid db 0

nop
startme:
        mov ax, [02ch]          ; Get enviroment
        mov es, ax
        mov ah, 49h             ; Free...
        int 21h                 ; ...memory

    mov ax, 35FDh
    int 21h
    mov ax, es
    mov [retjmp+1], bx
    mov [retjmp+3], ax

    mov ax, 25FDh
    mov dx, dstrt
    int 21h

    mov ax, 35FEh
    int 21h
    mov ax, es:[bx]
    mov [mydrvid], al

    mov dx, startme
    int 27h
