
#ifndef DEFBUF
#define DEFBUF 32768
#endif

#ifndef MAXHANDLE
#define MAXHANDLE 128
#endif

#define HANDLE_NONE 0
#define HANDLE_HEAP 1
#define HANDLE_DOSMEM 2
#define HANDLE_FILE 3

struct aresmem
    {
    UCHR type;
    UCHR owner;
    void far *pntr;
    ULNG size;
    } hdata[MAXHANDLE];

UCHR freehandle()
    {
    UINT i;
    for(i=0;i<MAXHANDLE;i++)
        if(hdata[i].type == HANDLE_NONE)
            return i;
    return 255;
    }

void freesomedosmem(UINT theseg)
    {
    _asm
        {
        mov ax, theseg
        mov es, ax
        mov ah, 49h
        int 21h
        }
    }

UINT getsomedosmem(UINT howmuch)
    {
    UINT i;
    _asm
        {
        mov ah, 48h
        mov bx, howmuch
        int 21h
        jc reserrr
        mov i, ax
        jmp noreserrr
reserrr: mov ax, 0
        mov i, ax
noreserrr:
        }
    return i;
    }

// The result of the functions is a handle (-1 if error)

void handle_free(UCHR handle)
    {
    switch(hdata[handle].type)
        {
        case HANDLE_HEAP:
            free(hdata[handle].pntr);
            hdata[handle].type = HANDLE_NONE;
            break;
        case HANDLE_FILE:
            fclose((FILE *) hdata[handle].pntr);
            hdata[handle].type = HANDLE_NONE;
            break;
        case HANDLE_DOSMEM:
            freesomedosmem(FP_SEG(hdata[handle].pntr));
            hdata[handle].type = HANDLE_NONE;
            break;
        }
    }

UCHR handle_malloc(UINT hmbyte, UCHR owner)
    {
    UCHR fhnd=freehandle();
    if(fhnd != 255)
        if((hdata[fhnd].pntr = malloc(hmbyte)) == NULL)
            fhnd = 255;
        else
            {
            hdata[fhnd].owner = owner;
            hdata[fhnd].size = hmbyte;
            hdata[fhnd].type = HANDLE_HEAP;
            }
    return fhnd;
    }

UCHR handle_dosmalloc(UINT hmbyte, UCHR owner)
    {
    UCHR fhnd=freehandle();
    if(fhnd != 255)
        if((hdata[fhnd].pntr = getsomedosmem((hmbyte + 15) / 16)) == NULL)
            fhnd = 255;
        else
            {
            hdata[fhnd].owner = owner;
            hdata[fhnd].size = hmbyte;
            hdata[fhnd].type = HANDLE_DOSMEM;
            }
    return fhnd;
    }


// The result of the functions is a pointer, null on error

void *handle_getmem(UCHR handle)
    {
    UCHR aah=hdata[handle].type;
    if((aah == HANDLE_HEAP) || (aah == HANDLE_DOSMEM))
        return hdata[handle].pntr;
    return NULL;
    }

void *handle_read(UCHR handle, ULNG startpos, UINT howmany, void *desti)
    {
    FILE *a;
    switch(hdata[handle].type)
        {
        case HANDLE_DOSMEM:
        case HANDLE_HEAP:
            memcpy(desti,hdata[handle].pntr + ((UINT) startpos),howmany);
            break;
        case HANDLE_FILE:
            a = (FILE *) hdata[handle].pntr;
            fseek(a, startpos, SEEK_SET);
            fread(desti,howmany,1,a);
            break;
        default: return NULL;
        }
    return desti;
    }

void *handle_write(UCHR handle, ULNG startpos, UINT howmany, void *srci)
    {
    FILE *a;
    switch(hdata[handle].type)
        {
        case HANDLE_DOSMEM:
        case HANDLE_HEAP:
            memcpy(hdata[handle].pntr + ((UINT) startpos),srci,howmany);
            break;
        case HANDLE_FILE:
            a = (FILE *) hdata[handle].pntr;
            fseek(a, startpos, SEEK_SET);
            fwrite(srci,howmany,1,a);
            break;
        default: return NULL;
        }
    return srci;
    }

// The result of the functions is a 0, any other value on error

UCHR handle_copy(UCHR shandle, ULNG spos, UCHR dhandle, ULNG dpos, ULNG howmany)
    {
    UINT bufsiz=DEFBUFSIZ;
    void *thebuf=NULL;

    while(thebuf == NULL)
        if((thebuf = malloc(bufsiz)) == NULL)
            bufsiz = bufsiz / 2;

        // Des da is no z duan

    free(thebuf);
    }

